/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
 
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"


/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "pikaScript.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
PikaObj* pikaMain;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
 

volatile static char rx_char = 0;
char UART1_RxBuff[RX_BUFF_LENGTH] = {0};
uint16_t UART1_RXBuff_offset = 0;
__attribute__((weak)) void __PIKA_USART1_IRQHandler(char rx_char) {}
void USART1_IRQHandler(void)
{
    if(USART_GetIntStatus(USART1, USART_INT_RXDNE) != RESET)
    {
        rx_char = USART_ReceiveData(USART1);
        __PIKA_USART1_IRQHandler(rx_char);
        /* clear buff when overflow */
        if(UART1_RXBuff_offset >= RX_BUFF_LENGTH)
        {
            UART1_RXBuff_offset = 0;
            memset(UART1_RxBuff, 0, sizeof(UART1_RxBuff));
        }
        /* recive char */
        UART1_RxBuff[UART1_RXBuff_offset] = rx_char;
        UART1_RXBuff_offset++;
        if('\n' == rx_char)
        {
            /* handle python script download */
            if(MCU_Code_reciveHandler(UART1_RxBuff, UART1_RXBuff_offset))
            {
                goto line_exit;
            }
line_exit:
            UART1_RXBuff_offset = 0;
            memset(UART1_RxBuff, 0, sizeof(UART1_RxBuff));
            return;
        }
    }
}

/* support pikaScript Shell */
char __platform_getchar()
{
    char res = 0;
    while(rx_char == 0)
    {
    };
    res = rx_char;
    rx_char = 0;
    return res;
}


int64_t pika_platform_getTick(void)
{
    return HAL_GetTick();
}

void pika_platform_sleep_ms(uint32_t ms)
{
    HAL_Delay(ms);
}

void pika_platform_sleep_s(uint32_t s)
{
    for(int i = 0; i < s; i++)
    {
        HAL_Delay(1000);
    }
}

extern PikaObj* __pikaMain;

int main(void)
{
    HAL_Init();
 
 
    HARDWARE_PRINTF_Init();
    printf("[info]: N32G4FR system init ok.\r\n");
    printf("------------------------------------------------------------------\r\n");
    printf("|                                                                |\r\n");
    printf("|     ____   _   __            _____              _          __  |\r\n");
    printf("|    / __ \\ (_) / /__ ____ _  / ___/ _____ _____ (_) ____   / /_ |\r\n");
    printf("|   / /_/ // / / //_// __ `/  \\__ \\ / ___// ___// / / __ \\ / __/ |\r\n");
    printf("|  / ____// / / ,<  / /_/ /  ___/ // /__ / /   / / / /_/ // /_   |\r\n");
    printf("| /_/    /_/ /_/|_| \\__,_/  /____/ \\___//_/   /_/ / .___/ \\__/   |\r\n");
    printf("|                                                /_/             |\r\n");
    printf("|          PikaScript - An Ultra Lightweight Python Engine       |\r\n");
    printf("|                                                                |\r\n");
    printf("|           [ https://github.com/pikastech/pikascript ]          |\r\n");
    printf("|           [  https://gitee.com/lyon1998/pikascript  ]          |\r\n");
    printf("|                                                                |\r\n");
    printf("------------------------------------------------------------------\r\n");
    /* boot pikaScript */
    char* code = (char*)FLASH_SCRIPT_START_ADDR;
    if(code[0] != 0xFF)
    {
        /* boot from flash */
        pikaMain = newRootObj("pikaMain", New_PikaMain);
        extern unsigned char pikaModules_py_a[];
        obj_linkLibrary(pikaMain, pikaModules_py_a);
        if(code[0] == 'i')
        {
            printf("[info]: boot from Script.\r\n");
            obj_run(pikaMain, code);
            goto main_loop;
        }
    }
    else
    {
        /* boot from firmware */
        pikaMain = pikaScriptInit();
        goto main_loop;
    }

    pikaMain = pikaScriptInit();
    goto main_loop;

main_loop:
    pikaScriptShell(pikaMain);
    /* after exit() from pika shell */
    NVIC_SystemReset();
}

 

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
    /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */
    __disable_irq();
    while(1)
    {
    }
    /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
